﻿using System;
using System.Linq;
using System.Reflection;

namespace Achiral.Extension
{
    public static partial class MakeWorld
    {
        public static FieldInfo[] GetAllFields(this Type type)
        {
            if (type == null) throw new ArgumentNullException("type");

            var flags = BindingFlags.Static
                      | BindingFlags.Instance
                      | BindingFlags.NonPublic
                      | BindingFlags.Public;

            return type.GetFields(flags);
        }
        public static MemberInfo[] GetAllMembers(this Type type)
        {
            if (type == null) throw new ArgumentNullException("type");

            var flags = BindingFlags.Static
                      | BindingFlags.Instance
                      | BindingFlags.NonPublic
                      | BindingFlags.Public;

            return type.GetMembers(flags);
        }
        public static MethodInfo[] GetAllMethods(this Type type)
        {
            if (type == null) throw new ArgumentNullException("type");

            var flags = BindingFlags.Static
                      | BindingFlags.Instance
                      | BindingFlags.NonPublic
                      | BindingFlags.Public;

            return type.GetMethods(flags);
        }
        public static PropertyInfo[] GetAllProperties(this Type type)
        {
            if (type == null) throw new ArgumentNullException("type");

            var flags = BindingFlags.Static
                      | BindingFlags.Instance
                      | BindingFlags.NonPublic
                      | BindingFlags.Public;

            return type.GetProperties(flags);
        }
    }
}